"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateListDomains = void 0;
const CodeartifactClient_1 = require("../CodeartifactClient");
const ListDomainsCommand_1 = require("../commands/ListDomainsCommand");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new ListDomainsCommand_1.ListDomainsCommand(input), ...args);
};
async function* paginateListDomains(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.nextToken = token;
        input["maxResults"] = config.pageSize;
        if (config.client instanceof CodeartifactClient_1.CodeartifactClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected Codeartifact | CodeartifactClient");
        }
        yield page;
        const prevToken = token;
        token = page.nextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
exports.paginateListDomains = paginateListDomains;
