import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
  StreamingBlobPayloadInputTypes,
} from "@smithy/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  PublishPackageVersionRequest,
  PublishPackageVersionResult,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface PublishPackageVersionCommandInput
  extends Pick<
    PublishPackageVersionRequest,
    Exclude<keyof PublishPackageVersionRequest, "assetContent">
  > {
  assetContent: StreamingBlobPayloadInputTypes;
}
export interface PublishPackageVersionCommandOutput
  extends PublishPackageVersionResult,
    __MetadataBearer {}
export declare class PublishPackageVersionCommand extends $Command<
  PublishPackageVersionCommandInput,
  PublishPackageVersionCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: PublishPackageVersionCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: PublishPackageVersionCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    PublishPackageVersionCommandInput,
    PublishPackageVersionCommandOutput
  >;
  private serialize;
  private deserialize;
}
