import { EndpointParameterInstructions } from "@smithy/middleware-endpoint";
import { Command as $Command } from "@smithy/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@smithy/types";
import {
  CodeartifactClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CodeartifactClient";
import {
  UpdatePackageVersionsStatusRequest,
  UpdatePackageVersionsStatusResult,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface UpdatePackageVersionsStatusCommandInput
  extends UpdatePackageVersionsStatusRequest {}
export interface UpdatePackageVersionsStatusCommandOutput
  extends UpdatePackageVersionsStatusResult,
    __MetadataBearer {}
export declare class UpdatePackageVersionsStatusCommand extends $Command<
  UpdatePackageVersionsStatusCommandInput,
  UpdatePackageVersionsStatusCommandOutput,
  CodeartifactClientResolvedConfig
> {
  readonly input: UpdatePackageVersionsStatusCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdatePackageVersionsStatusCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CodeartifactClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdatePackageVersionsStatusCommandInput,
    UpdatePackageVersionsStatusCommandOutput
  >;
  private serialize;
  private deserialize;
}
